#pragma once

#include <SFML/System/Vector2.hpp>
#include <cstddef>

class ILocationProvider {
  public:
  virtual sf::Vector2f get_pos() = 0;
  virtual float get_rot() = 0;
  virtual void update(std::size_t value_left, std::size_t value_right) = 0;
  virtual void reset(sf::Vector2f pos, float rot) = 0;
  virtual void hint_right(bool forward) = 0;
  virtual void hint_left(bool forward) = 0;
};
