#pragma once


#include "ILocationProvider.hpp"
#include <SFML/System/Vector2.hpp>
#include <optional>

struct Mission {
    sf::Vector2f from_pos, to_pos;
    float from_rot, to_rot;
    int total_encodings;
    int current_encodings;
    inline float progress() { return float(current_encodings) / float(total_encodings); }
};

class SimpleLocTracker : public ILocationProvider {
        std::optional<Mission> current_mission;
        sf::Vector2f last_pos;
        float last_rot;
        int last_step;

    public:
        inline SimpleLocTracker(sf::Vector2f pos, float rot) : last_pos(pos), last_rot(rot) {}
        void start(sf::Vector2f to_pos, float to_rot, int total_encodings);
        void progress();
        sf::Vector2f get_pos() override;
        float get_rot() override;
        void update(std::size_t value_left, std::size_t value_right) override {};
        void reset(sf::Vector2f pos, float rot) override{};
};
